##// END OF EJS Templates
fix: QEMU uboot (still problems)
drtyhlpr -
r267:173f1f262ec3
parent child
Show More
@@ -1,83 +1,88
1 1 #
2 2 # Build and Setup U-Boot
3 3 #
4 4
5 5 # Load utility functions
6 6 . ./functions.sh
7 7
8 8 # Fetch and build U-Boot bootloader
9 9 if [ "$ENABLE_UBOOT" = true ] ; then
10 10 # Install c/c++ build environment inside the chroot
11 11 chroot_install_cc
12 12
13 13 # Copy existing U-Boot sources into chroot directory
14 14 if [ -n "$UBOOTSRC_DIR" ] && [ -d "$UBOOTSRC_DIR" ] ; then
15 15 # Copy local U-Boot sources
16 16 cp -r "${UBOOTSRC_DIR}" "${R}/tmp"
17 17 else
18 18 # Create temporary directory for U-Boot sources
19 19 temp_dir=$(as_nobody mktemp -d)
20 20
21 21 # Fetch U-Boot sources
22 22 as_nobody git -C "${temp_dir}" clone "${UBOOT_URL}"
23 23
24 24 # Copy downloaded U-Boot sources
25 25 mv "${temp_dir}/u-boot" "${R}/tmp/"
26 26
27 27 # Set permissions of the U-Boot sources
28 28 chown -R root:root "${R}/tmp/u-boot"
29 29
30 30 # Remove temporary directory for U-Boot sources
31 31 rm -fr "${temp_dir}"
32 32 fi
33 33
34 34 # Build and install U-Boot inside chroot
35 35 chroot_exec make -j${KERNEL_THREADS} -C /tmp/u-boot/ ${UBOOT_CONFIG} all
36 36
37 37 # Copy compiled bootloader binary and set config.txt to load it
38 38 install_exec "${R}/tmp/u-boot/tools/mkimage" "${R}/usr/sbin/mkimage"
39 39 install_readonly "${R}/tmp/u-boot/u-boot.bin" "${BOOT_DIR}/u-boot.bin"
40 40 printf "\n# boot u-boot kernel\nkernel=u-boot.bin\n" >> "${BOOT_DIR}/config.txt"
41 41
42 42 # Install and setup U-Boot command file
43 43 install_readonly files/boot/uboot.mkimage "${BOOT_DIR}/uboot.mkimage"
44 44 printf "# Set the kernel boot command line\nsetenv bootargs \"earlyprintk ${CMDLINE}\"\n\n$(cat ${BOOT_DIR}/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
45 45
46 46 if [ "$ENABLE_INITRAMFS" = true ] ; then
47 47 # Convert generated initramfs for U-Boot using mkimage
48 48 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -T ramdisk -C none -n "initramfs-${KERNEL_VERSION}" -d "/boot/firmware/initramfs-${KERNEL_VERSION}" "/boot/firmware/initramfs-${KERNEL_VERSION}.uboot"
49 49
50 50 # Remove original initramfs file
51 51 rm -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}"
52 52
53 53 # Configure U-Boot to load generated initramfs
54 54 printf "# Set initramfs file\nsetenv initramfs initramfs-${KERNEL_VERSION}.uboot\n\n$(cat ${BOOT_DIR}/uboot.mkimage)" > "${BOOT_DIR}/uboot.mkimage"
55 55 printf "\nbootz \${kernel_addr_r} \${ramdisk_addr_r} \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
56 56 else # ENABLE_INITRAMFS=false
57 57 # Remove initramfs from U-Boot mkfile
58 58 sed -i '/.*initramfs.*/d' "${BOOT_DIR}/uboot.mkimage"
59 59
60 60 if [ "$BUILD_KERNEL" = false ] ; then
61 61 # Remove dtbfile from U-Boot mkfile
62 62 sed -i '/.*dtbfile.*/d' "${BOOT_DIR}/uboot.mkimage"
63 63 printf "\nbootz \${kernel_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
64 64 else
65 65 printf "\nbootz \${kernel_addr_r} - \${fdt_addr_r}" >> "${BOOT_DIR}/uboot.mkimage"
66 66 fi
67 67 fi
68 68
69 69 # Set mkfile to use the correct dtb file
70 70 sed -i "s/^\(setenv dtbfile \).*/\1${DTB_FILE}/" "${BOOT_DIR}/uboot.mkimage"
71 71
72 # Set mkfile to use the correct mach id
73 if [ "$ENABLE_QEMU" = true ] ; then
74 sed -i "s/^\(setenv machid \).*/\10x000008e0/" "${BOOT_DIR}/uboot.mkimage"
75 fi
76
72 77 # Set mkfile to use kernel image
73 78 sed -i "s/^\(fatload mmc 0:1 \${kernel_addr_r} \).*/\1${KERNEL_IMAGE}/" "${BOOT_DIR}/uboot.mkimage"
74 79
75 80 # Remove all leading blank lines
76 81 sed -i "/./,\$!d" "${BOOT_DIR}/uboot.mkimage"
77 82
78 83 # Generate U-Boot bootloader image
79 84 chroot_exec /usr/sbin/mkimage -A "${KERNEL_ARCH}" -O linux -T script -C none -a 0x00000000 -e 0x00000000 -n "RPi${RPI_MODEL}" -d /boot/firmware/uboot.mkimage /boot/firmware/boot.scr
80 85
81 86 # Remove U-Boot sources
82 87 rm -fr "${R}/tmp/u-boot"
83 88 fi
@@ -1,754 +1,769
1 1 #!/bin/sh
2 2
3 3 ########################################################################
4 4 # rpi23-gen-image.sh 2015-2017
5 5 #
6 6 # Advanced Debian "jessie", "stretch" and "buster" bootstrap script for RPi2/3
7 7 #
8 8 # This program is free software; you can redistribute it and/or
9 9 # modify it under the terms of the GNU General Public License
10 10 # as published by the Free Software Foundation; either version 2
11 11 # of the License, or (at your option) any later version.
12 12 #
13 13 # Copyright (C) 2015 Jan Wagner <mail@jwagner.eu>
14 14 #
15 15 # Big thanks for patches and enhancements by 20+ github contributors!
16 16 ########################################################################
17 17
18 18 # Are we running as root?
19 19 if [ "$(id -u)" -ne "0" ] ; then
20 20 echo "error: this script must be executed with root privileges!"
21 21 exit 1
22 22 fi
23 23
24 24 # Check if ./functions.sh script exists
25 25 if [ ! -r "./functions.sh" ] ; then
26 26 echo "error: './functions.sh' required script not found!"
27 27 exit 1
28 28 fi
29 29
30 30 # Load utility functions
31 31 . ./functions.sh
32 32
33 33 # Load parameters from configuration template file
34 34 if [ ! -z "$CONFIG_TEMPLATE" ] ; then
35 35 use_template
36 36 fi
37 37
38 38 # Introduce settings
39 39 set -e
40 40 echo -n -e "\n#\n# RPi2/3 Bootstrap Settings\n#\n"
41 41 set -x
42 42
43 43 # Raspberry Pi model configuration
44 44 RPI_MODEL=${RPI_MODEL:=2}
45 45
46 46 #bcm2708-rpi-0-w.dtb (Used for Pi 0 and PI 0W)
47 47 RPI0_DTB_FILE=${RPI0_DTB_FILE:=bcm2708-rpi-0-w.dtb}
48 48 RPI0_UBOOT_CONFIG=${RPI0_UBOOT_CONFIG:=rpi_defconfig}
49 49
50 50 #bcm2708-rpi-b.dtb (Used for Pi 1 model A and B)
51 51 RPI1_DTB_FILE=${RPI1_DTB_FILE:=bcm2708-rpi-b.dtb}
52 52 RPI1_UBOOT_CONFIG=${RPI1_UBOOT_CONFIG:=rpi_defconfig}
53 53
54 54 #bcm2708-rpi-b-plus.dtb (Used for Pi 1 model B+ and A+)
55 55 RPI1P_DTB_FILE=${RPI1P_DTB_FILE:=bcm2708-rpi-b-plus.dtb}
56 56 RPI1P_UBOOT_CONFIG=${RPI1P_UBOOT_CONFIG:=rpi_defconfig}
57 57
58 58 #bcm2709-rpi-2-b.dtb (Used for Pi 2 model B)
59 59 RPI2_DTB_FILE=${RPI2_DTB_FILE:=bcm2709-rpi-2-b.dtb}
60 60 RPI2_UBOOT_CONFIG=${RPI2_UBOOT_CONFIG:=rpi_2_defconfig}
61 61
62 62 #bcm2710-rpi-3-b.dtb (Used for Pi 3 model B)
63 63 RPI3_DTB_FILE=${RPI3_DTB_FILE:=bcm2710-rpi-3-b.dtb}
64 64 RPI3_UBOOT_CONFIG=${RPI3_UBOOT_CONFIG:=rpi_3_32b_defconfig}
65 65
66 66 #bcm2710-rpi-3-b-plus.dtb (Used for Pi 3 model B+)
67 67 RPI3P_DTB_FILE=${RPI3P_DTB_FILE:=bcm2710-rpi-3-b-plus.dtb}
68 68 RPI3P_UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG:=rpi_3_32b_defconfig}
69 69
70 70 # Debian release
71 71 RELEASE=${RELEASE:=jessie}
72 72 KERNEL_ARCH=${KERNEL_ARCH:=arm}
73 73 RELEASE_ARCH=${RELEASE_ARCH:=armhf}
74 74 CROSS_COMPILE=${CROSS_COMPILE:=arm-linux-gnueabihf-}
75 75 COLLABORA_KERNEL=${COLLABORA_KERNEL:=3.18.0-trunk-rpi2}
76 76 if [ "$KERNEL_ARCH" = "arm64" ] ; then
77 77 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi3_defconfig}
78 78 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel8.img}
79 79 fi
80 80
81 81 if [ "$RPI_MODEL" = 0 ] || [ "$RPI_MODEL" = 1 ] || [ "$RPI_MODEL" = 1P ] ; then
82 82 #RASPBERRY PI 1, PI ZERO, PI ZERO W, AND COMPUTE MODULE DEFAULT Kernel BUILD CONFIGURATION
83 83 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcmrpi_defconfig}
84 84 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
85 85 else
86 86 #RASPBERRY PI 2, PI 3, PI 3+, AND COMPUTE MODULE 3 DEFAULT Kernel BUILD CONFIGURATION
87 87 #https://www.raspberrypi.org/documentation/linux/kernel/building.md
88 88 KERNEL_DEFCONFIG=${KERNEL_DEFCONFIG:=bcm2709_defconfig}
89 89 KERNEL_IMAGE=${KERNEL_IMAGE:=kernel7.img}
90 90 fi
91 91
92 92 if [ "$RELEASE_ARCH" = "arm64" ] ; then
93 93 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-aarch64-static}
94 94 else
95 95 QEMU_BINARY=${QEMU_BINARY:=/usr/bin/qemu-arm-static}
96 96 fi
97 97 KERNEL_BRANCH=${KERNEL_BRANCH:=""}
98 98
99 99 # URLs
100 100 KERNEL_URL=${KERNEL_URL:=https://github.com/raspberrypi/linux}
101 101 FIRMWARE_URL=${FIRMWARE_URL:=https://github.com/raspberrypi/firmware/raw/master/boot}
102 102 WLAN_FIRMWARE_URL=${WLAN_FIRMWARE_URL:=https://github.com/RPi-Distro/firmware-nonfree/raw/master/brcm}
103 103 COLLABORA_URL=${COLLABORA_URL:=https://repositories.collabora.co.uk/debian}
104 104 FBTURBO_URL=${FBTURBO_URL:=https://github.com/ssvb/xf86-video-fbturbo.git}
105 105 UBOOT_URL=${UBOOT_URL:=https://git.denx.de/u-boot.git}
106 106
107 107 # Build directories
108 108 BASEDIR=${BASEDIR:=$(pwd)/images/${RELEASE}}
109 109 BUILDDIR="${BASEDIR}/build"
110 110
111 111 # Prepare date string for default image file name
112 112 DATE="$(date +%Y-%m-%d)"
113 113 if [ -z "$KERNEL_BRANCH" ] ; then
114 114 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
115 115 else
116 116 IMAGE_NAME=${IMAGE_NAME:=${BASEDIR}/${DATE}-${KERNEL_ARCH}-${KERNEL_BRANCH}-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
117 117 fi
118 118
119 119 # Chroot directories
120 120 R="${BUILDDIR}/chroot"
121 121 ETC_DIR="${R}/etc"
122 122 LIB_DIR="${R}/lib"
123 123 BOOT_DIR="${R}/boot/firmware"
124 124 KERNEL_DIR="${R}/usr/src/linux"
125 125 WLAN_FIRMWARE_DIR="${R}/lib/firmware/brcm"
126 126
127 127 # Firmware directory: Blank if download from github
128 128 RPI_FIRMWARE_DIR=${RPI_FIRMWARE_DIR:=""}
129 129
130 130 # General settings
131 131 HOSTNAME=${HOSTNAME:=rpi${RPI_MODEL}-${RELEASE}}
132 132 PASSWORD=${PASSWORD:=raspberry}
133 133 USER_PASSWORD=${USER_PASSWORD:=raspberry}
134 134 DEFLOCAL=${DEFLOCAL:="en_US.UTF-8"}
135 135 TIMEZONE=${TIMEZONE:="Europe/Berlin"}
136 136 EXPANDROOT=${EXPANDROOT:=true}
137 137
138 138 # Keyboard settings
139 139 XKB_MODEL=${XKB_MODEL:=""}
140 140 XKB_LAYOUT=${XKB_LAYOUT:=""}
141 141 XKB_VARIANT=${XKB_VARIANT:=""}
142 142 XKB_OPTIONS=${XKB_OPTIONS:=""}
143 143
144 144 # Network settings (DHCP)
145 145 ENABLE_DHCP=${ENABLE_DHCP:=true}
146 146
147 147 # Network settings (static)
148 148 NET_ADDRESS=${NET_ADDRESS:=""}
149 149 NET_GATEWAY=${NET_GATEWAY:=""}
150 150 NET_DNS_1=${NET_DNS_1:=""}
151 151 NET_DNS_2=${NET_DNS_2:=""}
152 152 NET_DNS_DOMAINS=${NET_DNS_DOMAINS:=""}
153 153 NET_NTP_1=${NET_NTP_1:=""}
154 154 NET_NTP_2=${NET_NTP_2:=""}
155 155
156 156 # APT settings
157 157 APT_PROXY=${APT_PROXY:=""}
158 158 APT_SERVER=${APT_SERVER:="ftp.debian.org"}
159 159
160 160 # Feature settings
161 161 ENABLE_CONSOLE=${ENABLE_CONSOLE:=true}
162 162 ENABLE_I2C=${ENABLE_I2C:=false}
163 163 ENABLE_SPI=${ENABLE_SPI:=false}
164 164 ENABLE_IPV6=${ENABLE_IPV6:=true}
165 165 ENABLE_SSHD=${ENABLE_SSHD:=true}
166 166 ENABLE_NONFREE=${ENABLE_NONFREE:=false}
167 167 ENABLE_WIRELESS=${ENABLE_WIRELESS:=false}
168 168 ENABLE_SOUND=${ENABLE_SOUND:=true}
169 169 ENABLE_DBUS=${ENABLE_DBUS:=true}
170 170 ENABLE_HWRANDOM=${ENABLE_HWRANDOM:=true}
171 171 ENABLE_MINGPU=${ENABLE_MINGPU:=false}
172 172 ENABLE_XORG=${ENABLE_XORG:=false}
173 173 ENABLE_WM=${ENABLE_WM:=""}
174 174 ENABLE_RSYSLOG=${ENABLE_RSYSLOG:=true}
175 175 ENABLE_USER=${ENABLE_USER:=true}
176 176 USER_NAME=${USER_NAME:="pi"}
177 177 ENABLE_ROOT=${ENABLE_ROOT:=false}
178 178 ENABLE_QEMU=${ENABLE_QEMU:=false}
179 179
180 180 # SSH settings
181 181 SSH_ENABLE_ROOT=${SSH_ENABLE_ROOT:=false}
182 182 SSH_DISABLE_PASSWORD_AUTH=${SSH_DISABLE_PASSWORD_AUTH:=false}
183 183 SSH_LIMIT_USERS=${SSH_LIMIT_USERS:=false}
184 184 SSH_ROOT_PUB_KEY=${SSH_ROOT_PUB_KEY:=""}
185 185 SSH_USER_PUB_KEY=${SSH_USER_PUB_KEY:=""}
186 186
187 187 # Advanced settings
188 188 ENABLE_MINBASE=${ENABLE_MINBASE:=false}
189 189 ENABLE_REDUCE=${ENABLE_REDUCE:=false}
190 190 ENABLE_UBOOT=${ENABLE_UBOOT:=false}
191 191 UBOOTSRC_DIR=${UBOOTSRC_DIR:=""}
192 192 ENABLE_FBTURBO=${ENABLE_FBTURBO:=false}
193 193 FBTURBOSRC_DIR=${FBTURBOSRC_DIR:=""}
194 194 ENABLE_HARDNET=${ENABLE_HARDNET:=false}
195 195 ENABLE_IPTABLES=${ENABLE_IPTABLES:=false}
196 196 ENABLE_SPLITFS=${ENABLE_SPLITFS:=false}
197 197 ENABLE_INITRAMFS=${ENABLE_INITRAMFS:=false}
198 198 ENABLE_IFNAMES=${ENABLE_IFNAMES:=true}
199 199 DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS:=}
200 200
201 201 # Kernel compilation settings
202 202 BUILD_KERNEL=${BUILD_KERNEL:=false}
203 203 KERNEL_REDUCE=${KERNEL_REDUCE:=false}
204 204 KERNEL_THREADS=${KERNEL_THREADS:=1}
205 205 KERNEL_HEADERS=${KERNEL_HEADERS:=true}
206 206 KERNEL_MENUCONFIG=${KERNEL_MENUCONFIG:=false}
207 207 KERNEL_REMOVESRC=${KERNEL_REMOVESRC:=true}
208 208 KERNEL_OLDDEFCONFIG=${KERNEL_OLDDEFCONFIG:=false}
209 209 KERNEL_CCACHE=${KERNEL_CCACHE:=false}
210 210
211 211 if [ "$KERNEL_ARCH" = "arm64" ] ; then
212 212 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="Image"}
213 213 else
214 214 KERNEL_BIN_IMAGE=${KERNEL_BIN_IMAGE:="zImage"}
215 215 fi
216 216
217 217 # Kernel compilation from source directory settings
218 218 KERNELSRC_DIR=${KERNELSRC_DIR:=""}
219 219 KERNELSRC_CLEAN=${KERNELSRC_CLEAN:=false}
220 220 KERNELSRC_CONFIG=${KERNELSRC_CONFIG:=true}
221 221 KERNELSRC_PREBUILT=${KERNELSRC_PREBUILT:=false}
222 222
223 223 # Reduce disk usage settings
224 224 REDUCE_APT=${REDUCE_APT:=true}
225 225 REDUCE_DOC=${REDUCE_DOC:=true}
226 226 REDUCE_MAN=${REDUCE_MAN:=true}
227 227 REDUCE_VIM=${REDUCE_VIM:=false}
228 228 REDUCE_BASH=${REDUCE_BASH:=false}
229 229 REDUCE_HWDB=${REDUCE_HWDB:=true}
230 230 REDUCE_SSHD=${REDUCE_SSHD:=true}
231 231 REDUCE_LOCALE=${REDUCE_LOCALE:=true}
232 232
233 233 # Encrypted filesystem settings
234 234 ENABLE_CRYPTFS=${ENABLE_CRYPTFS:=false}
235 235 CRYPTFS_PASSWORD=${CRYPTFS_PASSWORD:=""}
236 236 CRYPTFS_MAPPING=${CRYPTFS_MAPPING:="secure"}
237 237 CRYPTFS_CIPHER=${CRYPTFS_CIPHER:="aes-xts-plain64:sha512"}
238 238 CRYPTFS_XTSKEYSIZE=${CRYPTFS_XTSKEYSIZE:=512}
239 239
240 240 # Chroot scripts directory
241 241 CHROOT_SCRIPTS=${CHROOT_SCRIPTS:=""}
242 242
243 243 # Packages required in the chroot build environment
244 244 APT_INCLUDES=${APT_INCLUDES:=""}
245 245 APT_INCLUDES="${APT_INCLUDES},apt-transport-https,apt-utils,ca-certificates,debian-archive-keyring,dialog,sudo,systemd,sysvinit-utils"
246 246
247 247 # Packages required for bootstrapping
248 248 REQUIRED_PACKAGES="debootstrap debian-archive-keyring qemu-user-static binfmt-support dosfstools rsync bmap-tools whois git bc psmisc dbus sudo"
249 249 MISSING_PACKAGES=""
250 250
251 251 # Packages installed for c/c++ build environment in chroot (keep empty)
252 252 COMPILER_PACKAGES=""
253 253
254 254 set +x
255 255
256 256 # Set Raspberry Pi model specific configuration
257 257 if [ "$RPI_MODEL" = 0 ] ; then
258 258 DTB_FILE=${RPI2_DTB_FILE}
259 259 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
260 260 elif [ "$RPI_MODEL" = 1 ] ; then
261 261 DTB_FILE=${RPI2_DTB_FILE}
262 262 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
263 263 elif [ "$RPI_MODEL" = 1P ] ; then
264 264 DTB_FILE=${RPI2_DTB_FILE}
265 265 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
266 266 elif [ "$RPI_MODEL" = 2 ] ; then
267 267 DTB_FILE=${RPI2_DTB_FILE}
268 268 UBOOT_CONFIG=${RPI2_UBOOT_CONFIG}
269 269 elif [ "$RPI_MODEL" = 3 ] ; then
270 270 DTB_FILE=${RPI3_DTB_FILE}
271 271 UBOOT_CONFIG=${RPI3_UBOOT_CONFIG}
272 272 BUILD_KERNEL=true
273 273 elif [ "$RPI_MODEL" = 3P ] ; then
274 274 DTB_FILE=${RPI3P_DTB_FILE}
275 275 UBOOT_CONFIG=${RPI3P_UBOOT_CONFIG}
276 276 BUILD_KERNEL=true
277 277 else
278 278 echo "error: Raspberry Pi model ${RPI_MODEL} is not supported!"
279 279 exit 1
280 280 fi
281 281
282 282 # Check if the internal wireless interface is supported by the RPi model
283 283 if [ "$ENABLE_WIRELESS" = true ] && [ "$RPI_MODEL" = 2 ]; then
284 284 echo "error: The selected Raspberry Pi model has no internal wireless interface"
285 285 exit 1
286 286 fi
287 287
288 288 # Check if DISABLE_UNDERVOLT_WARNINGS parameter value is supported
289 289 if [ ! -z "$DISABLE_UNDERVOLT_WARNINGS" ] ; then
290 290 if [ "$DISABLE_UNDERVOLT_WARNINGS" != 1 ] && [ "$DISABLE_UNDERVOLT_WARNINGS" != 2 ] ; then
291 291 echo "error: DISABLE_UNDERVOLT_WARNINGS=${DISABLE_UNDERVOLT_WARNINGS} is not supported"
292 292 exit 1
293 293 fi
294 294 fi
295 295
296 296 # Build RPi2/3 Linux kernel if required by Debian release
297 297 if [ "$RELEASE" = "stretch" ] || [ "$RELEASE" = "buster" ] ; then
298 298 BUILD_KERNEL=true
299 299 fi
300 300
301 301 # Add packages required for kernel cross compilation
302 302 if [ "$BUILD_KERNEL" = true ] ; then
303 303 if [ "$KERNEL_ARCH" = "arm" ] ; then
304 304 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-armhf"
305 305 else
306 306 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} crossbuild-essential-arm64"
307 307 fi
308 308 fi
309 309
310 310 # Add libncurses5 to enable kernel menuconfig
311 311 if [ "$KERNEL_MENUCONFIG" = true ] ; then
312 312 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} libncurses5-dev"
313 313 fi
314 314
315 315 # Add ccache compiler cache for (faster) kernel cross (re)compilation
316 316 if [ "$KERNEL_CCACHE" = true ] ; then
317 317 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} ccache"
318 318 fi
319 319
320 320 # Add cryptsetup package to enable filesystem encryption
321 321 if [ "$ENABLE_CRYPTFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
322 322 REQUIRED_PACKAGES="${REQUIRED_PACKAGES} cryptsetup"
323 323 APT_INCLUDES="${APT_INCLUDES},cryptsetup,busybox,console-setup"
324 324
325 325 if [ -z "$CRYPTFS_PASSWORD" ] ; then
326 326 echo "error: no password defined (CRYPTFS_PASSWORD)!"
327 327 exit 1
328 328 fi
329 329 ENABLE_INITRAMFS=true
330 330 fi
331 331
332 332 # Add initramfs generation tools
333 333 if [ "$ENABLE_INITRAMFS" = true ] && [ "$BUILD_KERNEL" = true ] ; then
334 334 APT_INCLUDES="${APT_INCLUDES},initramfs-tools"
335 335 fi
336 336
337 337 # Add device-tree-compiler required for building the U-Boot bootloader
338 338 if [ "$ENABLE_UBOOT" = true ] ; then
339 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler"
339 APT_INCLUDES="${APT_INCLUDES},device-tree-compiler,bison,flex"
340 340 fi
341 341
342 342 # Check if root SSH (v2) public key file exists
343 343 if [ ! -z "$SSH_ROOT_PUB_KEY" ] ; then
344 344 if [ ! -f "$SSH_ROOT_PUB_KEY" ] ; then
345 345 echo "error: '$SSH_ROOT_PUB_KEY' specified SSH public key file not found (SSH_ROOT_PUB_KEY)!"
346 346 exit 1
347 347 fi
348 348 fi
349 349
350 350 # Check if $USER_NAME SSH (v2) public key file exists
351 351 if [ ! -z "$SSH_USER_PUB_KEY" ] ; then
352 352 if [ ! -f "$SSH_USER_PUB_KEY" ] ; then
353 353 echo "error: '$SSH_USER_PUB_KEY' specified SSH public key file not found (SSH_USER_PUB_KEY)!"
354 354 exit 1
355 355 fi
356 356 fi
357 357
358 358 # Check if all required packages are installed on the build system
359 359 for package in $REQUIRED_PACKAGES ; do
360 360 if [ "`dpkg-query -W -f='${Status}' $package`" != "install ok installed" ] ; then
361 361 MISSING_PACKAGES="${MISSING_PACKAGES} $package"
362 362 fi
363 363 done
364 364
365 365 # If there are missing packages ask confirmation for install, or exit
366 366 if [ -n "$MISSING_PACKAGES" ] ; then
367 367 echo "the following packages needed by this script are not installed:"
368 368 echo "$MISSING_PACKAGES"
369 369
370 370 echo -n "\ndo you want to install the missing packages right now? [y/n] "
371 371 read confirm
372 372 [ "$confirm" != "y" ] && exit 1
373 373
374 374 # Make sure all missing required packages are installed
375 375 apt-get -qq -y install ${MISSING_PACKAGES}
376 376 fi
377 377
378 378 # Check if ./bootstrap.d directory exists
379 379 if [ ! -d "./bootstrap.d/" ] ; then
380 380 echo "error: './bootstrap.d' required directory not found!"
381 381 exit 1
382 382 fi
383 383
384 384 # Check if ./files directory exists
385 385 if [ ! -d "./files/" ] ; then
386 386 echo "error: './files' required directory not found!"
387 387 exit 1
388 388 fi
389 389
390 390 # Check if specified KERNELSRC_DIR directory exists
391 391 if [ -n "$KERNELSRC_DIR" ] && [ ! -d "$KERNELSRC_DIR" ] ; then
392 392 echo "error: '${KERNELSRC_DIR}' specified directory not found (KERNELSRC_DIR)!"
393 393 exit 1
394 394 fi
395 395
396 396 # Check if specified UBOOTSRC_DIR directory exists
397 397 if [ -n "$UBOOTSRC_DIR" ] && [ ! -d "$UBOOTSRC_DIR" ] ; then
398 398 echo "error: '${UBOOTSRC_DIR}' specified directory not found (UBOOTSRC_DIR)!"
399 399 exit 1
400 400 fi
401 401
402 402 # Check if specified FBTURBOSRC_DIR directory exists
403 403 if [ -n "$FBTURBOSRC_DIR" ] && [ ! -d "$FBTURBOSRC_DIR" ] ; then
404 404 echo "error: '${FBTURBOSRC_DIR}' specified directory not found (FBTURBOSRC_DIR)!"
405 405 exit 1
406 406 fi
407 407
408 408 # Check if specified CHROOT_SCRIPTS directory exists
409 409 if [ -n "$CHROOT_SCRIPTS" ] && [ ! -d "$CHROOT_SCRIPTS" ] ; then
410 410 echo "error: ${CHROOT_SCRIPTS} specified directory not found (CHROOT_SCRIPTS)!"
411 411 exit 1
412 412 fi
413 413
414 414 # Check if specified device mapping already exists (will be used by cryptsetup)
415 415 if [ -r "/dev/mapping/${CRYPTFS_MAPPING}" ] ; then
416 416 echo "error: mapping /dev/mapping/${CRYPTFS_MAPPING} already exists, not proceeding"
417 417 exit 1
418 418 fi
419 419
420 420 # Don't clobber an old build
421 421 if [ -e "$BUILDDIR" ] ; then
422 422 echo "error: directory ${BUILDDIR} already exists, not proceeding"
423 423 exit 1
424 424 fi
425 425
426 426 # Setup chroot directory
427 427 mkdir -p "${R}"
428 428
429 429 # Check if build directory has enough of free disk space >512MB
430 430 if [ "$(df --output=avail ${BUILDDIR} | sed "1d")" -le "524288" ] ; then
431 431 echo "error: ${BUILDDIR} not enough space left to generate the output image!"
432 432 exit 1
433 433 fi
434 434
435 435 set -x
436 436
437 437 # Call "cleanup" function on various signals and errors
438 438 trap cleanup 0 1 2 3 6
439 439
440 440 # Add required packages for the minbase installation
441 441 if [ "$ENABLE_MINBASE" = true ] ; then
442 442 APT_INCLUDES="${APT_INCLUDES},vim-tiny,netbase,net-tools,ifupdown"
443 443 fi
444 444
445 445 # Add required locales packages
446 446 if [ "$DEFLOCAL" != "en_US.UTF-8" ] ; then
447 447 APT_INCLUDES="${APT_INCLUDES},locales,keyboard-configuration,console-setup"
448 448 fi
449 449
450 450 # Add parted package, required to get partprobe utility
451 451 if [ "$EXPANDROOT" = true ] ; then
452 452 APT_INCLUDES="${APT_INCLUDES},parted"
453 453 fi
454 454
455 455 # Add dbus package, recommended if using systemd
456 456 if [ "$ENABLE_DBUS" = true ] ; then
457 457 APT_INCLUDES="${APT_INCLUDES},dbus"
458 458 fi
459 459
460 460 # Add iptables IPv4/IPv6 package
461 461 if [ "$ENABLE_IPTABLES" = true ] ; then
462 462 APT_INCLUDES="${APT_INCLUDES},iptables"
463 463 fi
464 464
465 465 # Add openssh server package
466 466 if [ "$ENABLE_SSHD" = true ] ; then
467 467 APT_INCLUDES="${APT_INCLUDES},openssh-server"
468 468 fi
469 469
470 470 # Add alsa-utils package
471 471 if [ "$ENABLE_SOUND" = true ] ; then
472 472 APT_INCLUDES="${APT_INCLUDES},alsa-utils"
473 473 fi
474 474
475 475 # Add rng-tools package
476 476 if [ "$ENABLE_HWRANDOM" = true ] ; then
477 477 APT_INCLUDES="${APT_INCLUDES},rng-tools"
478 478 fi
479 479
480 480 # Add fbturbo video driver
481 481 if [ "$ENABLE_FBTURBO" = true ] ; then
482 482 # Enable xorg package dependencies
483 483 ENABLE_XORG=true
484 484 fi
485 485
486 486 # Add user defined window manager package
487 487 if [ -n "$ENABLE_WM" ] ; then
488 488 APT_INCLUDES="${APT_INCLUDES},${ENABLE_WM}"
489 489
490 490 # Enable xorg package dependencies
491 491 ENABLE_XORG=true
492 492 fi
493 493
494 494 # Add xorg package
495 495 if [ "$ENABLE_XORG" = true ] ; then
496 496 APT_INCLUDES="${APT_INCLUDES},xorg,dbus-x11"
497 497 fi
498 498
499 499 # Replace selected packages with smaller clones
500 500 if [ "$ENABLE_REDUCE" = true ] ; then
501 501 # Add levee package instead of vim-tiny
502 502 if [ "$REDUCE_VIM" = true ] ; then
503 503 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/vim-tiny/levee/")"
504 504 fi
505 505
506 506 # Add dropbear package instead of openssh-server
507 507 if [ "$REDUCE_SSHD" = true ] ; then
508 508 APT_INCLUDES="$(echo ${APT_INCLUDES} | sed "s/openssh-server/dropbear/")"
509 509 fi
510 510 fi
511 511
512 512 if [ "$RELEASE" != "jessie" ] ; then
513 513 APT_INCLUDES="${APT_INCLUDES},libnss-systemd"
514 514 fi
515 515
516 516 # Configure kernel sources if no KERNELSRC_DIR
517 517 if [ "$BUILD_KERNEL" = true ] && [ -z "$KERNELSRC_DIR" ] ; then
518 518 KERNELSRC_CONFIG=true
519 519 fi
520 520
521 521 # Configure reduced kernel
522 522 if [ "$KERNEL_REDUCE" = true ] ; then
523 523 KERNELSRC_CONFIG=false
524 524 fi
525 525
526 526 # Configure qemu compatible kernel
527 527 if [ "$ENABLE_QEMU" = true ] ; then
528 DTB_FILE=vexpress-v2p-ca15_a7.dtb
529 UBOOT_CONFIG=vexpress_ca15_tc2_defconfig
528 530 KERNEL_DEFCONFIG="vexpress_defconfig"
529 531 if [ "$KERNEL_MENUCONFIG" = false ] ; then
530 532 KERNEL_OLDDEFCONFIG=true
531 533 fi
532 534 fi
533 535
534 536 # Execute bootstrap scripts
535 537 for SCRIPT in bootstrap.d/*.sh; do
536 538 head -n 3 "$SCRIPT"
537 539 . "$SCRIPT"
538 540 done
539 541
540 542 ## Execute custom bootstrap scripts
541 543 if [ -d "custom.d" ] ; then
542 544 for SCRIPT in custom.d/*.sh; do
543 545 . "$SCRIPT"
544 546 done
545 547 fi
546 548
547 549 # Execute custom scripts inside the chroot
548 550 if [ -n "$CHROOT_SCRIPTS" ] && [ -d "$CHROOT_SCRIPTS" ] ; then
549 551 cp -r "${CHROOT_SCRIPTS}" "${R}/chroot_scripts"
550 552 chroot_exec /bin/bash -x <<'EOF'
551 553 for SCRIPT in /chroot_scripts/* ; do
552 554 if [ -f $SCRIPT -a -x $SCRIPT ] ; then
553 555 $SCRIPT
554 556 fi
555 557 done
556 558 EOF
557 559 rm -rf "${R}/chroot_scripts"
558 560 fi
559 561
560 562 # Remove c/c++ build environment from the chroot
561 563 chroot_remove_cc
562 564
563 565 # Remove apt-utils
564 566 if [ "$RELEASE" = "jessie" ] ; then
565 567 chroot_exec apt-get purge -qq -y --force-yes apt-utils
566 568 fi
567 569
568 570 # Generate required machine-id
569 571 MACHINE_ID=$(dbus-uuidgen)
570 572 echo -n "${MACHINE_ID}" > "${R}/var/lib/dbus/machine-id"
571 573 echo -n "${MACHINE_ID}" > "${ETC_DIR}/machine-id"
572 574
573 575 # APT Cleanup
574 576 chroot_exec apt-get -y clean
575 577 chroot_exec apt-get -y autoclean
576 578 chroot_exec apt-get -y autoremove
577 579
578 580 # Unmount mounted filesystems
579 581 umount -l "${R}/proc"
580 582 umount -l "${R}/sys"
581 583
582 584 # Clean up directories
583 585 rm -rf "${R}/run/*"
584 586 rm -rf "${R}/tmp/*"
585 587
586 588 # Clean up files
587 589 rm -f "${ETC_DIR}/ssh/ssh_host_*"
588 590 rm -f "${ETC_DIR}/dropbear/dropbear_*"
589 591 rm -f "${ETC_DIR}/apt/sources.list.save"
590 592 rm -f "${ETC_DIR}/resolvconf/resolv.conf.d/original"
591 593 rm -f "${ETC_DIR}/*-"
592 594 rm -f "${ETC_DIR}/apt/apt.conf.d/10proxy"
593 595 rm -f "${ETC_DIR}/resolv.conf"
594 596 rm -f "${R}/root/.bash_history"
595 597 rm -f "${R}/var/lib/urandom/random-seed"
596 598 rm -f "${R}/initrd.img"
597 599 rm -f "${R}/vmlinuz"
598 600 rm -f "${R}${QEMU_BINARY}"
599 601
600 602 if [ "$ENABLE_QEMU" = true ] ; then
601 603 # Setup QEMU directory
602 604 mkdir "${BASEDIR}/qemu"
603 605
604 606 # Copy kernel image to QEMU directory
605 607 install_readonly "${BOOT_DIR}/${KERNEL_IMAGE}" "${BASEDIR}/qemu/${KERNEL_IMAGE}"
606 608
607 609 # Copy kernel config to QEMU directory
608 610 install_readonly "${R}/boot/config-${KERNEL_VERSION}" "${BASEDIR}/qemu/config-${KERNEL_VERSION}"
609 611
610 612 # Copy kernel dtbs to QEMU directory
611 613 for dtb in "${BOOT_DIR}/"*.dtb ; do
612 614 if [ -f "${dtb}" ] ; then
613 615 install_readonly "${dtb}" "${BASEDIR}/qemu/"
614 616 fi
615 617 done
616 618
617 619 # Copy kernel overlays to QEMU directory
618 620 if [ -d "${BOOT_DIR}/overlays" ] ; then
619 621 # Setup overlays dtbs directory
620 622 mkdir "${BASEDIR}/qemu/overlays"
621 623
622 624 for dtb in "${BOOT_DIR}/overlays/"*.dtb ; do
623 625 if [ -f "${dtb}" ] ; then
624 626 install_readonly "${dtb}" "${BASEDIR}/qemu/overlays/"
625 627 fi
626 628 done
627 629 fi
628 630
631 # Copy u-boot files to QEMU directory
632 if [ "$ENABLE_UBOOT" = true ] ; then
633 if [ -f "${BOOT_DIR}/u-boot.bin" ] ; then
634 install_readonly "${BOOT_DIR}/u-boot.bin" "${BASEDIR}/qemu/u-boot.bin"
635 fi
636 if [ -f "${BOOT_DIR}/uboot.mkimage" ] ; then
637 install_readonly "${BOOT_DIR}/uboot.mkimage" "${BASEDIR}/qemu/uboot.mkimage"
638 fi
639 if [ -f "${BOOT_DIR}/boot.scr" ] ; then
640 install_readonly "${BOOT_DIR}/boot.scr" "${BASEDIR}/qemu/boot.scr"
641 fi
642 fi
643
629 644 # Copy initramfs to QEMU directory
630 645 if [ -f "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" ] ; then
631 646 install_readonly "${BOOT_DIR}/initramfs-${KERNEL_VERSION}" "${BASEDIR}/qemu/initramfs-${KERNEL_VERSION}"
632 647 fi
633 648 fi
634 649
635 650 # Calculate size of the chroot directory in KB
636 651 CHROOT_SIZE=$(expr `du -s "${R}" | awk '{ print $1 }'`)
637 652
638 653 # Calculate the amount of needed 512 Byte sectors
639 654 TABLE_SECTORS=$(expr 1 \* 1024 \* 1024 \/ 512)
640 655 FRMW_SECTORS=$(expr 64 \* 1024 \* 1024 \/ 512)
641 656 ROOT_OFFSET=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS})
642 657
643 658 # The root partition is EXT4
644 659 # This means more space than the actual used space of the chroot is used.
645 660 # As overhead for journaling and reserved blocks 35% are added.
646 661 ROOT_SECTORS=$(expr $(expr ${CHROOT_SIZE} + ${CHROOT_SIZE} \/ 100 \* 35) \* 1024 \/ 512)
647 662
648 663 # Calculate required image size in 512 Byte sectors
649 664 IMAGE_SECTORS=$(expr ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS})
650 665
651 666 # Prepare image file
652 667 if [ "$ENABLE_SPLITFS" = true ] ; then
653 668 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=${TABLE_SECTORS}
654 669 dd if=/dev/zero of="$IMAGE_NAME-frmw.img" bs=512 count=0 seek=${FRMW_SECTORS}
655 670 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=${TABLE_SECTORS}
656 671 dd if=/dev/zero of="$IMAGE_NAME-root.img" bs=512 count=0 seek=${ROOT_SECTORS}
657 672
658 673 # Write firmware/boot partition tables
659 674 sfdisk -q -L -uS -f "$IMAGE_NAME-frmw.img" 2> /dev/null <<EOM
660 675 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
661 676 EOM
662 677
663 678 # Write root partition table
664 679 sfdisk -q -L -uS -f "$IMAGE_NAME-root.img" 2> /dev/null <<EOM
665 680 ${TABLE_SECTORS},${ROOT_SECTORS},83
666 681 EOM
667 682
668 683 # Setup temporary loop devices
669 684 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME-frmw.img)"
670 685 ROOT_LOOP="$(losetup -o 1M -f --show $IMAGE_NAME-root.img)"
671 686 else # ENABLE_SPLITFS=false
672 687 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=${TABLE_SECTORS}
673 688 dd if=/dev/zero of="$IMAGE_NAME.img" bs=512 count=0 seek=${IMAGE_SECTORS}
674 689
675 690 # Write partition table
676 691 sfdisk -q -L -uS -f "$IMAGE_NAME.img" 2> /dev/null <<EOM
677 692 ${TABLE_SECTORS},${FRMW_SECTORS},c,*
678 693 ${ROOT_OFFSET},${ROOT_SECTORS},83
679 694 EOM
680 695
681 696 # Setup temporary loop devices
682 697 FRMW_LOOP="$(losetup -o 1M --sizelimit 64M -f --show $IMAGE_NAME.img)"
683 698 ROOT_LOOP="$(losetup -o 65M -f --show $IMAGE_NAME.img)"
684 699 fi
685 700
686 701 if [ "$ENABLE_CRYPTFS" = true ] ; then
687 702 # Create dummy ext4 fs
688 703 mkfs.ext4 "$ROOT_LOOP"
689 704
690 705 # Setup password keyfile
691 706 touch .password
692 707 chmod 600 .password
693 708 echo -n ${CRYPTFS_PASSWORD} > .password
694 709
695 710 # Initialize encrypted partition
696 711 echo "YES" | cryptsetup luksFormat "${ROOT_LOOP}" -c "${CRYPTFS_CIPHER}" -s "${CRYPTFS_XTSKEYSIZE}" .password
697 712
698 713 # Open encrypted partition and setup mapping
699 714 cryptsetup luksOpen "${ROOT_LOOP}" -d .password "${CRYPTFS_MAPPING}"
700 715
701 716 # Secure delete password keyfile
702 717 shred -zu .password
703 718
704 719 # Update temporary loop device
705 720 ROOT_LOOP="/dev/mapper/${CRYPTFS_MAPPING}"
706 721
707 722 # Wipe encrypted partition (encryption cipher is used for randomness)
708 723 dd if=/dev/zero of="${ROOT_LOOP}" bs=512 count=$(blockdev --getsz "${ROOT_LOOP}")
709 724 fi
710 725
711 726 # Build filesystems
712 727 mkfs.vfat "$FRMW_LOOP"
713 728 mkfs.ext4 "$ROOT_LOOP"
714 729
715 730 # Mount the temporary loop devices
716 731 mkdir -p "$BUILDDIR/mount"
717 732 mount "$ROOT_LOOP" "$BUILDDIR/mount"
718 733
719 734 mkdir -p "$BUILDDIR/mount/boot/firmware"
720 735 mount "$FRMW_LOOP" "$BUILDDIR/mount/boot/firmware"
721 736
722 737 # Copy all files from the chroot to the loop device mount point directory
723 738 rsync -a "${R}/" "$BUILDDIR/mount/"
724 739
725 740 # Unmount all temporary loop devices and mount points
726 741 cleanup
727 742
728 743 # Create block map file(s) of image(s)
729 744 if [ "$ENABLE_SPLITFS" = true ] ; then
730 745 # Create block map files for "bmaptool"
731 746 bmaptool create -o "$IMAGE_NAME-frmw.bmap" "$IMAGE_NAME-frmw.img"
732 747 bmaptool create -o "$IMAGE_NAME-root.bmap" "$IMAGE_NAME-root.img"
733 748
734 749 # Image was successfully created
735 750 echo "$IMAGE_NAME-frmw.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
736 751 echo "$IMAGE_NAME-root.img ($(expr \( ${TABLE_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
737 752 else
738 753 # Create block map file for "bmaptool"
739 754 bmaptool create -o "$IMAGE_NAME.bmap" "$IMAGE_NAME.img"
740 755
741 756 # Image was successfully created
742 757 echo "$IMAGE_NAME.img ($(expr \( ${TABLE_SECTORS} + ${FRMW_SECTORS} + ${ROOT_SECTORS} \) \* 512 \/ 1024 \/ 1024)M)" ": successfully created"
743 758
744 759 # Create qemu qcow2 image
745 760 if [ "$ENABLE_QEMU" = true ] ; then
746 761 QEMU_IMAGE=${QEMU_IMAGE:=${BASEDIR}/qemu/${DATE}-${KERNEL_ARCH}-CURRENT-rpi${RPI_MODEL}-${RELEASE}-${RELEASE_ARCH}}
747 762 QEMU_SIZE=16G
748 763
749 764 qemu-img convert -f raw -O qcow2 $IMAGE_NAME.img $QEMU_IMAGE.qcow2
750 765 qemu-img resize $QEMU_IMAGE.qcow2 $QEMU_SIZE
751 766
752 767 echo "$QEMU_IMAGE.qcow2 ($QEMU_SIZE)" ": successfully created"
753 768 fi
754 769 fi
General Comments 0
Vous devez vous connecter pour laisser un commentaire. Se connecter maintenant